#!/bin/bash

# Check if in $PWD/scripts directory
if [ "$(basename $PWD)" != "scripts" ]; then
  echo "You are not in the ./scripts directory. Change directory and run script again."
  exit 1
fi

# Variables
INPUT_FILE=ziti-edge-router_install_script.sh
OUTPUT_FILE=../casts/ziti-edge-router_install.cast

# Check if $OUTPUT_FILE exists
if [ -f $OUTPUT_FILE ]; then
  echo "File $OUTPUT_FILE already exists. Exiting."
  exit 1
fi

uv run asciinema-automation -dt 75 -sd 30 --asciinema-arguments " --cols=238 --rows=56 " $INPUT_FILE $OUTPUT_FILE