#$ delay 50
#$ expect \$

#$ sendcharacter # enter docker container where to install ziti-edge-router as service
#$ sendcontrol m
#$ expect \$
#$ wait 500

docker exec -it ziti-edge bash
#$ expect \$

#$ sendcharacter # install necessary packages
#$ sendcontrol m
#$ expect \$
#$ wait 500

sudo apt update
#$ expect \$
#$ wait 1000
sudo apt install -y wget jq
#$ expect \$

#$ sendcontrol j
#$ sendcharacter # set some variables first (you have to change the ROUTER_NAME and ZITI_ROUTER_ROLES for sure!)
#$ sendcontrol m
#$ expect \$
#$ wait 500

export ROUTER_NAME="ziti-private-yellow"
export ZITI_ROUTER_ROLES="zitiyellow"
export ZITI_ROUTER_PORT=8442
export ZITI_ROUTER_LISTENER_BIND_PORT=8444
export ZITI_EDGE_IDENTITY_ENROLLMENT_DURATION=10080
export ZITI_ROUTER_ENROLLMENT_DURATION=10080
export ZITI_CTRL_ADVERTISED_ADDRESS="ziti.starconnect.link"
export ZITI_CTRL_ADVERTISED_PORT=8440
export ZITI_CTRL_EDGE_ADVERTISED_PORT=8441
#$ expect \$

#$ sendcontrol j
#$ sendcharacter # make sure the address is addressable from the new edge router host and curl returns some json
#$ sendcontrol m
#$ expect \$
#$ wait 500

curl -sk https://$ZITI_CTRL_ADVERTISED_ADDRESS:$ZITI_CTRL_EDGE_ADVERTISED_PORT
#$ expect \$

#$ sendcontrol j
#$ sendcharacter # make sure **ziti-private-yellow** can see the link plane port
#$ sendcontrol m
#$ expect \$
#$ wait 500

curl -vsk -m 5 https://$ZITI_CTRL_ADVERTISED_ADDRESS:$ZITI_CTRL_ADVERTISED_PORT
#$ expect \$

#$ sendcontrol j
#$ sendcharacter # use getZiti to get the binaries (pass 'yes' to add ziti to your path)
#$ sendcontrol m
#$ expect \$
#$ wait 500

source /dev/stdin <<< "$(wget -qO- https://get.openziti.io/quick/ziti-cli-functions.sh)"; getZiti yes
#$ wait 2000
#$ sendcharacter y
#$ sendcontrol m
#$ expect \$

#$ sendcontrol j
#$ sendcharacter # login to the controller. easier if you do this from **ziti-private-yellow**, but not necessary (credentials are stored as *daystrom: OpenZiti admin* in Vaultwarden)
#$ sendcontrol m
#$ expect \$
#$ wait 500

cd $ZITI_HOME
ziti edge login $ZITI_CTRL_ADVERTISED_ADDRESS:$ZITI_CTRL_EDGE_ADVERTISED_PORT
#$ wait 1000
#$ sendcharacter admin
#$ sendcontrol m
#$ wait 1000
#$ sendcharacter <password>
#$ sendcontrol m
#$ expect \$

#$ sendcontrol j
#$ sendcharacter # create the **ziti-private-yellow** in the controller
#$ sendcontrol m
#$ expect \$
#$ wait 500

ziti edge create edge-router -t $ROUTER_NAME -o $ZITI_HOME/$ROUTER_NAME.jwt
#$ expect \$

#$ sendcontrol j
#$ sendcharacter # create a config file and decide if this is a **private** edge router or public. this makes the router **private**, meaning it won't advertise that routers should link to it
#$ sendcontrol m
#$ expect \$
#$ wait 500

ziti create config router edge --routerName $ROUTER_NAME \
                               --output $ZITI_HOME/$ROUTER_NAME.yaml \
                               --tunnelerMode host \
                               --private
#$ expect \$

#$ sendcontrol j
#$ sendcharacter # make necessary changes to the configuration file
#$ sendcontrol m
#$ expect \$
#$ wait 500

sed "s|tls:ziti.starconnect.link:8440|tls:daystrom.starconnect.link:8440|" $ZITI_HOME/$ROUTER_NAME.yaml > $ZITI_HOME/$ROUTER_NAME.yaml
#$ expect \$
sed "s|tls:$(hostname -s):8444|tls:ziti-private-yellow:8444|" $ZITI_HOME/$ROUTER_NAME.yaml > $ZITI_HOME/$ROUTER_NAME.yaml
#$ expect \$
sed "s|$(hostname -s):8442|ziti-private-yellow:8442|" $ZITI_HOME/$ROUTER_NAME.yaml > $ZITI_HOME/$ROUTER_NAME.yaml
#$ expect \$
sed "s|- $(hostname -s)|- ziti-private-yellow|" $ZITI_HOME/$ROUTER_NAME.yaml > $ZITI_HOME/$ROUTER_NAME.yaml
#$ expect \$

#$ sendcontrol j
#$ sendcharacter # enroll the router (does not matter which config you use, i chose the private one here)
#$ sendcontrol m
#$ expect \$
#$ wait 500

ziti router enroll $ZITI_HOME/$ROUTER_NAME.yaml --jwt $ZITI_HOME/$ROUTER_NAME.jwt
#$ expect \$

#$ sendcontrol j
#$ sendcharacter # run the public or private **ziti-private-yellow** config
#$ sendcontrol m
#$ expect \$
#$ wait 500

ziti router run $ZITI_HOME/$ROUTER_NAME.yaml
#$ wait 5000
#$ sendcontrol c
#$ expect \$

#$ sendcontrol j
#$ sendcharacter # make systemd unit file
#$ sendcontrol m
#$ expect \$
#$ wait 500

createRouterSystemdFile $ROUTER_NAME
#$ expect \$

#$ sendcontrol j
#$ sendcharacter # systemd file stuff (optional)
#$ sendcontrol m
#$ expect \$
#$ wait 500

sudo cp $ZITI_HOME/$ROUTER_NAME.service /etc/systemd/system/ziti-router.service
#$ expect \$
sudo systemctl daemon-reload
#$ expect \$
sudo systemctl enable --now ziti-router
#$ expect \$

#$ sendcontrol j
#$ sendcharacter # make sure **ziti-private-yellow** shows online
#$ sendcontrol m
#$ expect \$
#$ wait 500

ziti edge list edge-routers
#$ expect \$

#$ sendcontrol j
#$ sendcharacter # make sure it is linked
#$ sendcontrol m
#$ expect \$
#$ wait 500

ziti fabric list links
#$ expect \$

# exit docker container session to gracefully exit asciinema recording
exit